Index: code/trunk/src/network/GamestateClient.cc
===================================================================
--- code/trunk/src/network/GamestateClient.cc	(revision 1735)
+++ code/trunk/src/network/GamestateClient.cc	(revision 1735)
@@ -0,0 +1,161 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss
+ *   Co-authors:
+ *      Dumeni Manatschal
+ *
+ */
+
+#include "GamestateClient.h"
+
+#include <zlib.h>
+
+#include "core/CoreIncludes.h"
+#include "core/BaseObject.h"
+#include "Synchronisable.h"
+
+
+namespace network
+{
+  struct GameStateItem{
+    packet::Gamestate *state;
+    int id;
+  };
+
+  GamestateClient::GamestateClient() {
+    COUT(5) << "this: " << this << std::endl;
+    last_diff_=0;
+    last_gamestate_=GAMESTATEID_INITIAL-1;
+    tempGamestate_=NULL;
+    myShip_=NULL;
+  }
+
+  GamestateClient::~GamestateClient() {
+  }
+
+  bool GamestateClient::ack(int gamestateID, int clientID){
+    return true;
+  }
+
+  bool GamestateClient::add(packet::Gamestate *gs, int clientID){
+    if(tempGamestate_!=NULL){
+      //delete the obsolete gamestate
+      if(tempGamestate_->getID()>gs->getID())
+        return false;
+      delete tempGamestate_;
+    }
+    tempGamestate_=gs;
+    return true;
+  }
+  
+  int GamestateClient::processGamestates(){
+    if(tempGamestate_==NULL)
+      return 0;
+    int id = GAMESTATEID_INITIAL;
+    bool b = saveShipCache();
+    if(processGamestate(tempGamestate_)){
+      if(b)
+        loadShipCache();
+      id = tempGamestate_->getID();
+    }
+    cleanup();
+    return id;
+  }
+
+
+  /**
+  * This function removes a Synchronisable out of the universe
+  * @param it iterator of the list pointing to the object
+  * @return iterator pointing to the next object in the list
+  */
+  void GamestateClient::removeObject(orxonox::Iterator<Synchronisable> &it) {
+    orxonox::Iterator<Synchronisable> temp=it;
+    ++it;
+    delete  *temp;
+  }
+
+  packet::Gamestate *GamestateClient::getGamestate(){
+    packet::Gamestate *gs = new packet::Gamestate();
+    gs->collectData(GAMESTATEID_INITIAL);
+    return gs;
+  }
+
+  void GamestateClient::cleanup(){
+    std::map<int, packet::Gamestate*>::iterator temp, it = gamestateMap_.begin();
+    while(it!=gamestateMap_.end()){
+      if(it->first>=last_diff_)
+        break;
+      // otherwise delete that stuff
+      delete (*it).second;
+      temp=it++;
+      gamestateMap_.erase(temp);
+    }
+    tempGamestate_=NULL;
+  }
+
+  void GamestateClient::printGamestateMap(){
+    std::map<int, packet::Gamestate*>::iterator it;
+    COUT(4) << "gamestates: ";
+    for(it=gamestateMap_.begin(); it!=gamestateMap_.end(); it++){
+      COUT(4) << it->first << ":" << it->second << "|";
+    }
+    COUT(4) << std::endl;
+
+  }
+
+  bool GamestateClient::saveShipCache(){
+    if(myShip_==NULL)
+      myShip_ = orxonox::SpaceShip::getLocalShip();
+    if(myShip_){
+      //      unsigned char *data = new unsigned char[myShip_->getSize()];
+      int size=myShip_->getSize(0x1);
+      if(size==0)
+        return false;
+      shipCache_ = new unsigned char [size];
+      unsigned char *temp = shipCache_;
+      if(!myShip_->getData2(temp, 0x1))
+        COUT(3) << "could not save shipCache" << std::endl;
+      return true;
+    }else
+      return false;
+  }
+
+  bool GamestateClient::loadShipCache(){
+    if(myShip_ && shipCache_){
+      unsigned char *temp = shipCache_;
+      myShip_->updateData(temp, 0x2);
+      delete shipCache_;
+      return true;
+    }else
+      return false;
+  }
+
+  bool GamestateClient::processGamestate(packet::Gamestate *gs){
+    assert(gs->decompressData());
+    if(gs->isDiffed())
+      assert(gs->undiff(gamestateMap_[gs->getBaseID()]));
+    return gs->spreadData();
+  }
+
+}
+
Index: code/trunk/src/network/GamestateClient.h
===================================================================
--- code/trunk/src/network/GamestateClient.h	(revision 1735)
+++ code/trunk/src/network/GamestateClient.h	(revision 1735)
@@ -0,0 +1,85 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss
+ *   Co-authors:
+ *      Dumeni Manatschal
+ *
+ */
+
+//
+// C++ Interface: GameStateClient
+//
+// Description:
+//
+//
+// Author:  Oliver Scheuss, (C) 2007
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#ifndef _GamestateClient_H__
+#define _GamestateClient_H__
+
+#include <map>
+// 
+#include "NetworkPrereqs.h"
+#include "core/CorePrereqs.h"
+#include "packet/Gamestate.h"
+#include "objects/SpaceShip.h"
+#include "GamestateHandler.h"
+
+#define GAMESTATEID_INITIAL -1
+
+namespace network
+{
+  class GamestateClient: public GamestateHandler
+  {
+  public:
+    GamestateClient();
+    ~GamestateClient();
+    
+    bool add(packet::Gamestate *gs, int clientID);
+    bool ack(int gamestateID, int clientID);
+    
+    int processGamestates();
+    packet::Gamestate *getGamestate();
+    void cleanup();
+  private:
+    bool processGamestate(packet::Gamestate *gs);
+    void removeObject(orxonox::Iterator<Synchronisable> &it);
+    void printGamestateMap();
+    bool saveShipCache();
+    bool loadShipCache();
+
+    int           last_diff_;
+    int           last_gamestate_;
+    std::map<int, packet::Gamestate *> gamestateMap_;
+    packet::Gamestate *tempGamestate_; // we save the received gamestates here during processQueue
+    orxonox::SpaceShip *myShip_;
+    unsigned char *shipCache_;
+    
+  };
+
+}
+
+#endif /* _GamestateClient_H__ */
Index: code/trunk/src/network/GamestateHandler.cc
===================================================================
--- code/trunk/src/network/GamestateHandler.cc	(revision 1735)
+++ code/trunk/src/network/GamestateHandler.cc	(revision 1735)
@@ -0,0 +1,24 @@
+#include <assert.h>
+
+#include "GamestateHandler.h"
+#include "packet/Packet.h"
+
+namespace network {
+
+GamestateHandler *GamestateHandler::instance_=0;
+  
+GamestateHandler::GamestateHandler()
+{
+  assert(instance_==0);
+  instance_=this;
+}
+
+
+GamestateHandler::~GamestateHandler()
+{
+  instance_=0;
+}
+
+
+
+}//namespace network
Index: code/trunk/src/network/GamestateHandler.h
===================================================================
--- code/trunk/src/network/GamestateHandler.h	(revision 1735)
+++ code/trunk/src/network/GamestateHandler.h	(revision 1735)
@@ -0,0 +1,60 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss <scheusso [at] ee.ethz.ch>, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+#ifndef NETWORKGAMESTATEHANDLER_H
+#define NETWORKGAMESTATEHANDLER_H
+
+#include <string>
+
+#include "NetworkPrereqs.h"
+#include "packet/Chat.h"
+
+namespace network {
+
+/**
+	@author Oliver Scheuss
+*/
+class GamestateHandler{
+  private:
+    virtual bool add(packet::Gamestate *gs, int clientID)=0;
+    virtual bool ack(int gamestateID, int clientID)=0;
+    
+    static GamestateHandler *instance_;
+    
+    
+  protected:
+    GamestateHandler();
+    ~GamestateHandler();
+    
+  public:
+    static bool addGamestate(packet::Gamestate *gs, int clientID){ return instance_->add(gs, clientID); }
+    static bool ackGamestate(int gamestateID, int clientID){ return instance_->ack(gamestateID, clientID); }
+};
+
+}
+
+#endif
Index: code/trunk/src/network/GamestateManager.cc
===================================================================
--- code/trunk/src/network/GamestateManager.cc	(revision 1735)
+++ code/trunk/src/network/GamestateManager.cc	(revision 1735)
@@ -0,0 +1,205 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss, (C) 2007
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+//
+// C++ Implementation: GameStateManager
+//
+// Description:
+//
+//
+// Author:  Oliver Scheuss, (C) 2007
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+#include "GamestateManager.h"
+
+#include <utility>
+#include <iostream>
+#include <zlib.h>
+#include <assert.h>
+
+#include "core/CoreIncludes.h"
+#include "core/BaseObject.h"
+#include "ClientInformation.h"
+#include "Synchronisable.h"
+
+namespace network
+{
+  GamestateManager::GamestateManager() {
+    id_=0;
+  }
+
+  GamestateManager::~GamestateManager() {
+  }
+
+  bool GamestateManager::update(){
+    cleanup();
+    return getSnapshot();
+  }
+  
+  bool GamestateManager::add(packet::Gamestate *gs, int clientID){
+    assert(gs);
+    std::map<int, packet::Gamestate*>::iterator it = gamestateQueue.find(clientID);
+    if(it!=gamestateQueue.end()){
+      // delete obsolete gamestate
+      delete it->second;
+    }
+    gamestateQueue[clientID] = gs;
+    return true;
+  }
+  
+  bool GamestateManager::processGamestates(){
+    std::map<int, packet::Gamestate*>::iterator it;
+    // now push only the most recent gamestates we received (ignore obsolete ones)
+    for(it = gamestateQueue.begin(); it!=gamestateQueue.end(); it++){
+      assert(processGamestate(it->second));
+      delete it->second;
+    }
+    // now clear the queue
+    gamestateQueue.clear();
+    return true;
+  }
+  
+  
+  bool GamestateManager::getSnapshot(){
+    reference = new packet::Gamestate();
+    reference->collectData(++id_);
+    COUT(4) << "inserting gamestate: " << reference << std::endl;
+    gamestateMap.insert(std::pair<int, packet::Gamestate*>(id_, reference));
+    gamestateUsed[id_]=0;
+    return true;
+  }
+  
+  /**
+   * this function is used to keep the memory usage low
+   * it tries to delete all the unused gamestates
+   * 
+   * 
+   */
+  void GamestateManager::cleanup(){
+    std::map<int,int>::iterator it = gamestateUsed.begin();
+    while(it!=gamestateUsed.end()){
+      if((id_-(*it).first)<KEEP_GAMESTATES)
+        break;
+      if( (*it).second <= 0 ){
+        COUT(5) << "GameStateManager: deleting gamestate with id: " << (*it).first << ", uses: " << (*it).second << std::endl;
+        std::map<int, packet::Gamestate *>::iterator tempit = gamestateMap.find((*it).first);
+        if( tempit != gamestateMap.end() ){
+          packet::Gamestate *temp = tempit->second;
+          if(temp){
+            delete gamestateMap[(*it).first];
+            gamestateMap.erase((*it).first);
+          }
+        }
+        gamestateUsed.erase(it++);
+        continue;
+      }
+      it++;
+    }
+  }
+
+  packet::Gamestate *GamestateManager::popGameState(int clientID) {
+    //why are we searching the same client's gamestate id as we searched in
+    //Server::sendGameState?
+    int gID = ClientInformation::findClient(clientID)->getGamestateID();
+    COUT(4) << "G.St.Man: popgamestate: sending gstate_id: " << id_ << " diffed from: " << gID << std::endl;
+//     COUT(3) << "gamestatemap: " << &gameStateMap << std::endl;
+    //chose wheather the next gamestate is the first or not
+    if(gID != GAMESTATEID_INITIAL){
+      // TODO something with the gamestatemap is wrong
+      packet::Gamestate *client=NULL;
+      std::map<int, packet::Gamestate*>::iterator it = gamestateMap.find(gID);
+      if(it!=gamestateMap.end())
+        client = it->second;
+      packet::Gamestate *gs;
+      if(client)
+        gs = reference->diff(client);
+      else
+        gs = new packet::Gamestate(*reference);
+      gs->compressData();
+      return gs;
+    } else {
+      COUT(4) << "we got a GAMESTATEID_INITIAL for clientID: " << clientID << std::endl;
+//       ackGameState(clientID, reference->id);
+      return new packet::Gamestate(*reference);
+      // return an undiffed gamestate and set appropriate flags
+    }
+  }
+  
+  
+  bool GamestateManager::ack(int gamestateID, int clientID) {
+    ClientInformation *temp = ClientInformation::findClient(clientID);
+    if(temp==0)
+      return false;
+    int curid = temp->getGamestateID();
+    
+    if(gamestateID == GAMESTATEID_INITIAL){
+      temp->setGamestateID(GAMESTATEID_INITIAL);
+      if(curid!=GAMESTATEID_INITIAL){
+        assert(gamestateUsed.find(curid)!=gamestateUsed.end());
+        --(gamestateUsed.find(curid)->second);
+      }
+      return false;
+    }
+    if(curid > gamestateID)
+      // the network packets got messed up 
+      return true;
+    COUT(4) << "acking gamestate " << gamestateID << " for clientid: " << clientID << " curid: " << curid << std::endl;
+    // decrease usage of gamestate and save it
+//     deleteUnusedGameState(curid);
+    //increase gamestateused
+    std::map<int, int>::iterator it = gamestateUsed.find(curid);
+    if(curid!=GAMESTATEID_INITIAL){
+      if(it!=gamestateUsed.end())
+        --(it->second);
+    }
+    it = gamestateUsed.find(gamestateID);
+    if(it!=gamestateUsed.end()){
+      ++(it->second);
+      temp->setGamestateID(gamestateID);
+    }
+    return true;
+  }
+
+  void GamestateManager::removeClient(ClientInformation* client){
+    if(!client)
+      return;
+    if(client->getGamestateID()>=0)
+      gamestateUsed[client->getGamestateID()]--;
+    ClientInformation::removeClient(client->getID());
+  }
+  
+  bool GamestateManager::processGamestate(packet::Gamestate *gs){
+    assert(gs->decompressData());
+    assert(!gs->isDiffed());
+    return gs->spreadData();
+  }
+
+}
Index: code/trunk/src/network/GamestateManager.h
===================================================================
--- code/trunk/src/network/GamestateManager.h	(revision 1735)
+++ code/trunk/src/network/GamestateManager.h	(revision 1735)
@@ -0,0 +1,95 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss, (C) 2007
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+//
+// C++ Interface: GamestateManager
+//
+// Description:
+//
+//
+// Author:  Oliver Scheuss, (C) 2007
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#ifndef _GamestateManager_H__
+#define _GamestateManager_H__
+
+#include "NetworkPrereqs.h"
+#include "GamestateHandler.h"
+#include <map>
+
+#include "packet/Gamestate.h"
+
+namespace network
+{
+
+#define KEEP_GAMESTATES 10
+
+  /**
+  * This Class implements a manager for gamestates:
+  * - creating snapshots of gamestates
+  * - writing gamestates to universe
+  * - diffing gamestates
+  * EN/DECODATION:
+  * a: last Gamestate a client has received
+  * b: new Gamestate
+  * x: diffed and compressed gamestate
+  * x=(a^b)
+  * b=(a^x)
+  * diff(a,diff(a,x))=x (hope this is correct)
+  * @author Oliver Scheuss
+  */
+  class GamestateManager: public GamestateHandler{
+  public:
+    GamestateManager();
+    ~GamestateManager();
+    
+    bool add(packet::Gamestate *gs, int clientID);
+    bool processGamestates();
+    bool update();
+    packet::Gamestate *popGameState(int clientID);
+
+    bool getSnapshot();
+    
+    bool ack(int gamestateID, int clientID);
+    void removeClient(ClientInformation *client);
+    private:
+    void cleanup(); // "garbage handler"
+    bool processGamestate(packet::Gamestate *gs);
+    
+    std::map<int, packet::Gamestate*> gamestateMap; //map gsID to gamestate*
+    std::map<int, int> gamestateUsed; // save the number of clients, that use the specific gamestate
+    std::map<int, packet::Gamestate*> gamestateQueue;
+    packet::Gamestate *reference;
+    int id_;
+  };
+
+}
+
+#endif /* _GameStateManager_H__ */
Index: code/trunk/src/network/Host.cc
===================================================================
--- code/trunk/src/network/Host.cc	(revision 1735)
+++ code/trunk/src/network/Host.cc	(revision 1735)
@@ -0,0 +1,56 @@
+#include <assert.h>
+
+#include "Host.h"
+#include "packet/Packet.h"
+
+namespace network {
+
+Host *Host::instance_=0;
+  
+Host::Host()
+{
+  assert(instance_==0);
+  instance_=this;
+}
+
+
+Host::~Host()
+{
+  instance_=0;
+}
+
+bool Host::addPacket(ENetPacket *packet, int clientID){
+  if(instance_)
+    return instance_->queuePacket(packet, clientID);
+  else
+    return false;
+}
+
+
+// bool Host::chat(std::string& message){
+//   if(!instance_)
+//     return false;
+//   packet::Chat *c = new packet::Chat(message, getPlayerID());
+//   return instance_->sendChat(c);
+// }
+
+// bool Host::receiveChat(network::packet::Chat *message, unsigned int clientID){
+//   if(instance_)
+//     return instance_->processChat(message, clientID);
+//   else
+//     return false;
+// }
+
+int Host::getPlayerID(){ 
+  if(!instance_)
+    return 0;
+  return instance_->playerID();
+}
+
+// unsigned int Host::getShipID(){ 
+//   if(!instance_)
+//     assert(0);
+//   return instance_->shipID();
+// }
+
+}//namespace network
Index: code/trunk/src/network/Host.h
===================================================================
--- code/trunk/src/network/Host.h	(revision 1735)
+++ code/trunk/src/network/Host.h	(revision 1735)
@@ -0,0 +1,73 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Oliver Scheuss <scheusso [at] ee.ethz.ch>, (C) 2008
+ *   Co-authors:
+ *      ...
+ *
+ */
+#ifndef NETWORKHOST_H
+#define NETWORKHOST_H
+
+#include <string>
+
+#include "NetworkPrereqs.h"
+#include "packet/Chat.h"
+
+namespace network {
+
+/**
+	@author Oliver Scheuss
+*/
+class Host{
+  private:
+    //TODO add theese functions or adequate
+    //virtual bool processChat(packet::Chat *message, unsigned int clientID)=0;
+    //virtual bool sendChat(packet::Chat *chat)=0;
+    virtual bool queuePacket(ENetPacket *packet, int clientID)=0;
+    virtual unsigned int shipID()=0;
+    virtual int playerID()=0;
+    
+    
+    
+  protected:
+    Host();
+    ~Host();
+    static Host *instance_;
+    
+  public:
+    static bool running(){return instance_!=0;}
+    static bool addPacket(ENetPacket *packet, int clientID=0);
+    //static bool chat(std::string& message);
+//     static bool receiveChat(packet::Chat *message, unsigned int clientID);
+    static int getPlayerID();
+    static unsigned int getShipID(){return instance_->shipID_;}
+    static void setClientID(unsigned int id){ instance_->clientID_ = id; }
+    static void setShipID(unsigned int id){ instance_->shipID_ = id; }
+  private:
+    unsigned int clientID_;
+    unsigned int shipID_;
+};
+
+}
+
+#endif
Index: code/trunk/src/network/NetworkPrereqs.h
===================================================================
--- code/trunk/src/network/NetworkPrereqs.h	(revision 1639)
+++ code/trunk/src/network/NetworkPrereqs.h	(revision 1735)
@@ -66,26 +66,24 @@
   class ClientInformation;
   class ConnectionManager;
-  class GameStateClient;
-  class GameStateManager;
+  class GamestateClient;
+  class GamestateManager;
+  class GamestateHandler;
   class PacketBuffer;
-  class PacketDecoder;
-  class PacketGenerator;
   class Server;
   class ServerFrameListener;
   class Synchronisable;
-  struct ack;
-  struct chat;
-  struct classid;
-  struct welcome;
-  struct connectRequest;
   struct ClientList;
-  struct GameState;
-  struct GameStateCompressed;
-  struct keyboard;
-  struct mouse;
   struct PacketEnvelope;
   struct QueueItem;
   struct syncData;
   struct synchronisableVariable;
+  namespace packet{
+    class Gamestate;
+    class Packet;
+    class Acknowledgement;
+    class ClassID;
+    class Welcome;
+    class Chat;
+  }
 }
 
